/*
Active Desktop Calendar 1.9 by
Gerald Riechmann <grichman@cs.tu-berlin.de>
http://user.cs.tu-berlin.de/~grichman/

Additional programming by
Thomas Riechmann <thomas.riechmann@informatik.uni-erlangen.de>
http://www4.informatik.uni-erlangen.de/~riechmann/

To change fonts, colors and backgrounds, edit one of the files
Desktop Calendar Style User 1.css
Desktop Calendar Style User 2.css

Active Desktop Calendar is freeware for non-commercial (!) users.

You may modify the code for your personal use, but not publish changed 
versions (on webpages etc.).
*/

var promptTitel = 'Active Desktop Calendar\n';

var cssURLs = new Array('Desktop Calendar Style.css', 'Desktop Calendar Style User 1.css', 'Desktop Calendar Style User 2.css');


var dblClickWait = 200;
var keyPress = false;

var cookieExpire = new Date(); 
cookieExpire.setMonth(cookieExpire.getMonth()+6);


var channelBar=' <OBJECT id=0 name="DeskMovrW" style="position:absolute; Background=orange; HEIGHT: 426; LEFT: 684; TOP: 123; WIDTH: 84; Z-INDEX: 10016" resizeable="XY" classid="clsid:131A6951-7F78-11D0-A979-00C04FD705A2"> </OBJECT> 	';

var moverObjs = ' <OBJECT classid="clsid:72267F6A-A6F9-11D0-BC94-00C04FB67863" id=ActiveDesktopMover STYLE="position:absolute; container:positioned; LEFT: 0;TOP: 0; WIDTH: 1; HEIGHT: 1;zIndex: 5" > <param name="Interval" value="500"> <param name="SizerID" value="ActiveDesktopMover"> <param name="Enabled" value="True"> <param name="TargetName" value="DeskMovr"> <param name="WindowOnly" value="False"> </OBJECT>  <OBJECT classid="clsid:72267F6A-A6F9-11D0-BC94-00C04FB67863" id=ActiveDesktopMoverW STYLE="position:absolute; container:positioned; LEFT: 0;TOP: 0; WIDTH: 1; HEIGHT: 1;zIndex 19" > <param name="Interval" value="500"> <param name="SizerID" value="ActiveDesktopMoverW"> <param name="Enabled" value="True"> <param name="TargetName" value="DeskMovrW"> <param name="WindowOnly" value="True"> </OBJECT> 	';

function setCookie(name, value, expire) {
   document.cookie = escape(name) + "=" + escape(value) + (expire ? ("; expires=" + expire.toGMTString()) : "");
}

function getCookie(name) {
	var search = escape(name) + "=";
	var offset = document.cookie.indexOf(search);
	if (offset == -1) return '';
	offset += search.length;
	var end = document.cookie.indexOf(";", offset);
	if (end == -1) end = document.cookie.length;
	return unescape(document.cookie.substring(offset, end));
}

function calLang(language, monthNames, dayNames){
	this.language = language;
	this.monthNames = monthNames.split(' ');
	this.dayNames = dayNames.split(' ');
}

var languages = new Array(
	new calLang('English', 'January February March April May June July August September October November December', 'Sunday Monday Tuesday Wednesday Thursday Friday Saturday'),
	new calLang('Deutsch', 'Januar Februar Mrz April Mai Juni Juli August September Oktober November Dezember', 'Sonntag Montag Dienstag Mittwoch Donnerstag Freitag Samstag'),
	new calLang('Franais', 'Janvier Fvrier Mars Avril Mai Juin Juillet Aot Septembre Octobre Novembre Dcembre', 'Dimanche Lundi Mardi Mercredi Jeudi Vendredi Samedi'),
	new calLang('Italiano', 'Gennaio Febbraio Marzo Aprile Maggio Giugno Luglio Agosto Settembre Ottobre Novembre Dicembre', 'Domenica Luned Marted Mercoled Gioved Venerd Sabato'),
	new calLang('Portugus', 'Janeiro Fevereiro Maro Abril Maio Junho Julho Agosto Setembro Outubro Novembro Dezembro', 'Domingo Segunda-feira Tera-feira Quarta-feira Quinta-feira Sexta-feira Sbado'),
	new calLang('Espaol', 'Enero Febrero Marcha Abril Mayo Junio Julio Agosto Septiembre Octubre Noviembre Diciembre', 'Domingo Lunes Martes Mircoles Jueves Viernes Sbado'),
	new calLang('Nederlands', 'Januari Februari Maart April Mei Juni Juli Augustus September Oktober November December', 'Zondag Maandag Dinsdag Woensdag Donderdag Vrijdag Zaterdag')
)


function getYearY2K(){
	return (this.getYear() < 100) ? this.getYear() + 1900 : this.getYear();
}
Date.prototype.getYearY2K = getYearY2K;


function atMidnightDo(code){
	var now = new Date();
	var expireTime = new Date(now.getYear(), now.getMonth(), now.getDate() + 1, 0, 0, 1); 
	setTimeout(code, expireTime.getTime() - now.getTime());
}

function chCssURL(newCssURL){
	if(!newCssURL)return false;
	cssURL = newCssURL;
	setCookie('DesktopCalendarCssURL', cssURL, cookieExpire);
	return true;
}

function openInfo(href){
	window.showModalDialog(href, 0, 'border:thin; center:yes; dialogWidth:510px; dialogHeight:540px; help:no; maximize:no; minimize:no');
}

function promptMonthYear(enterString){
	var monthYear = new Array(2);
	var now = new Date();
	
	enterString = prompt(promptTitel + 'Enter month/year or just year.', enterString);
	if(!enterString) return false;
	monthYear = enterString.split('/', 1);
	
	var month = parseInt(monthYear[0]);
	var year = parseInt(monthYear[1]);
	
	if(!year){
		if(!month)return false;
		year = month;
		month = 1;
	}
	if(year < 0){alert(promptTitel+"Unknown year."); return false}
	if(year < 100){year += 1900}
	
	monthOffset = (year-now.getYearY2K())*12 + month-now.getMonth()-1;
	return true;
}

	
function chSettings(){
	language = document.settings.language.selectedIndex;
	setCookie('DesktopCalendarLanguage', language, cookieExpire);
	startWeekday = document.settings.startWeekday.selectedIndex;
	setCookie('DesktopCalendarStartWeekday', startWeekday, cookieExpire);
	cropWeekday = document.settings.cropWeekday.selectedIndex;
	setCookie('DesktopCalendarCropWeekday', cropWeekday, cookieExpire);
	cssURL = document.settings.cssURL.value || cssURLs[0];
	setCookie('DesktopCalendarCssURL', cssURL, cookieExpire);
	if(!getCookie('DesktopCalendarStartWeekday'))alert(promptTitel+'Please enable cookies to make settings permanent.');
}

function initSettings(){
	if(document.settings){
		document.settings.cropWeekday.selectedIndex = cropWeekday;
		document.settings.startWeekday.selectedIndex = startWeekday;
		document.settings.language.selectedIndex = language;
		document.settings.cssURL.value = cssURL;
	}
}


function init(){
	initSettings();
	atMidnightDo("desktopCalendar()");
}


function insertMenu(){
	document.all.topRow.innerHTML = displayOptions ? optionsMenu() : '';
	initSettings();
}


function optionsMenu(){
var menu = '<SPAN style="position: absolute; left: 10%; top: 30%; width: 80%; background-color: #CCC; filter:Alpha(opacity=85, style=0); border: outset 2px #FFF; font-family: sans-serif"; color: black> <FORM name=settings onSubmit="chSettings();desktopCalendar();return false"> <h1 style="color: black">Desktop Calendar Settings</h1> 		<SELECT name=language style="width:19%">';
	for(var i=0;i<languages.length;i++)
		menu += '<OPTION value=' + i + '>' + languages[i].language + '</OPTION>';
menu += '</SELECT><SELECT name=startWeekday style="width:40%"> <OPTION VALUE=0>Week starts with Sunday</OPTION> <OPTION VALUE=1>Week starts with Monday</OPTION> </SELECT><SELECT name=cropWeekday style="width:40%"> <OPTION VALUE=0>Display full weekdays</OPTION> <OPTION VALUE=1>Display weekdays as a single letter</OPTION> <OPTION VALUE=2>Display weekdays as 2 letters</OPTION> <OPTION VALUE=3>Display weekdays as 3 letters</OPTION> <OPTION VALUE=4>Display weekdays as 4 letters</OPTION> <OPTION VALUE=5>Display weekdays as 5 letters</OPTION> </SELECT><br> <INPUT size=50 Type=Text name=cssURL value="" style="width:99%" ><BR><INPUT type=button name=submit value=Ok onClick="displayOptions=false;chSettings();desktopCalendar()" ><INPUT type=button name=submit value=Apply onClick="chSettings();desktopCalendar()" ><INPUT type=button name=submit value=Cancel onClick="displayOptions=false;insertMenu()" 		></FORM></SPAN>';
	return menu;
}


function desktopCalendar(){
	var now = new Date();
	var thisMonth = new Date(now);
	thisMonth.setHours(12);
	thisMonth.setDate(1);
	thisMonth.setMonth(thisMonth.getMonth() + monthOffset);
	

	var countDate = new Date(thisMonth);
	countDate.setDate(countDate.getDate() - ((countDate.getDay() + 7 - startWeekday) % 7));

	var weekDayRow = '';
	for(var dayOfWeek = startWeekday; dayOfWeek < startWeekday + 7; dayOfWeek++){
		var dayName = languages[language].dayNames[dayOfWeek % 7];
		weekDayRow += '<TD>' + (cropWeekday ? dayName.substr(0, cropWeekday) : dayName) + '</TD>';
	}

	var calendarRows = '';
	var calendarRowsCount = 1;
	do{
		calendarRows += '<TR class=ThisMonth>';
		
		for(var dayOfWeek = startWeekday; dayOfWeek < startWeekday + 7; dayOfWeek++){
			calendarRows += ((countDate.getMonth() != thisMonth.getMonth()) ? '<TD class=OtherMonths>' :
				(((!monthOffset) && (countDate.getDate() == now.getDate())) ? '<TD class=Today' : '<TD class=DayOfWeek' + (dayOfWeek % 7)) + ' ID=Day' + countDate.getDate() + '>')
				+ countDate.getDate() + '</TD>';
			countDate.setDate(countDate.getDate()+1);
		}
		calendarRows += '</TR>';
		calendarRowsCount++;
	}while(countDate.getMonth() == thisMonth.getMonth());

var newCalendarPage = '<HTML> <HEAD> ' + baseHref + ' <TITLE>Active Desktop Calendar</TITLE> <LINK REL="stylesheet"  TYPE="text/css" HREF="' + escape(cssURL) + '">\n \n <SCRIPT Language="JavaScript"> var cssURL = unescape("' + escape(cssURL) + '");\n var moverHTML = unescape("' + escape(moverHTML) + '");\n var baseHref = unescape("' + escape(baseHref) + '");\n var monthOffset = ' + (monthOffset || 0) + ';\n var startWeekday = ' + (startWeekday || 0) + ';\n var cropWeekday = ' + (cropWeekday || 0) + ';\n var language = ' + (language || 0) + ';\n var displayOptions = ' + (displayOptions || false) + ';\n </SCRIPT>\n <SCRIPT Language="JavaScript" src="Desktop Calendar Script (1.9).js"></SCRIPT>\n \n \n </HEAD>\n <BODY onLoad="init()" class="Month' + (thisMonth.getMonth()+1) + '" ID="Year' + thisMonth.getYearY2K() + '">\n <TABLE class=OuterFrame> <TR><TD id=topRow colspan=2 valign=top>' + (displayOptions ? optionsMenu() : '') + '</TD></TR> <TR><TD class=OuterFrame id=LeftFrame> <SMALL class=Info> <A onMouseDown="keyPress=false;setTimeout(\'keyPress=true\', dblClickWait)" onClick="monthOffset-=(keyPress?12:1);desktopCalendar();return false" href="#">&nbsp;&lt;&lt;</A> <A onMouseDown="keyPress=false;setTimeout(\'keyPress=true\', dblClickWait)" onClick="if(keyPress){if(promptMonthYear(\'' + (thisMonth.getMonth()+1) + '/' + thisMonth.getYearY2K() + '\'))desktopCalendar()}else{monthOffset=0;desktopCalendar()} return false" href="#">&nbsp;+&nbsp;</A> <A onMouseDown="keyPress=false;setTimeout(\'keyPress=true\', dblClickWait)" onClick="monthOffset+=(keyPress?12:1);desktopCalendar();return false" href="#">&nbsp;&gt;&gt;</A> &nbsp; <A onClick="chCssURL(cssURLs[0]); desktopCalendar();return false" href="#">&nbsp;&nbsp;</A> <A onClick="chCssURL(cssURLs[1]); desktopCalendar();return false" href="#">&nbsp;1&nbsp;</A> <A onClick="chCssURL(cssURLs[2]); desktopCalendar();return false" href="#">&nbsp;2&nbsp;</A> &nbsp; <A onMouseDown="keyPress=false;setTimeout(\'keyPress=true\', dblClickWait)" onClick="if(keyPress){displayOptions=!displayOptions;insertMenu()}else{openInfo(this.href)} return false" target="_blank" href="Desktop Calendar Info.html">&nbsp;?&nbsp;</A>  <B>Active&nbsp;Desktop&nbsp;Calendar</B> </SMALL> </TD><TD class=OuterFrame id=RightFrame> <TABLE class=Calendar> <TR><TD colspan=8 class=Large id=MonthLarge>' + languages[language].monthNames[thisMonth.getMonth()] + '</TD></TR> 					<TR class=WeekdayTitle><TD rowspan=' + calendarRowsCount + ' class=Large id=YearLarge>' + thisMonth.getYearY2K() + '</TD>'
						+ weekDayRow + '</TR>' + calendarRows + 
'</TABLE> </TD></TR> 		</TABLE>'
		+ moverHTML +
'</BODY> </HTML>';
	
	document.open("text/html", "replace");
	document.writeln(newCalendarPage);
	document.close();
}
